/* header.h
**
**    Copyright (C) 2006  Wei Lian      <lianwei2003.student@sina.com>
**
**    This program is free software; you can redistribute it and/or modify
**    it under the terms of the GNU General Public License Version 2 as
**    published by the Free Software Foundation;
**
**    This program is distributed in the hope that it will be useful,
**    but WITHOUT ANY WARRANTY; without even the implied warranty of
**    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
**    GNU General Public License for more details.
**
**    You should have received a copy of the GNU General Public License
**    along with this program; if not, write to the Free Software
**    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
**
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <gtk/gtk.h>

#include <sys/soundcard.h>
#include <fcntl.h>

#include <stdio.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include <stdlib.h>
#include <signal.h>
#include <sys/time.h>

#include <string.h>

#include <unistd.h>
#include <termios.h>
#include <pthread.h>

#include <errno.h>
#include <regex.h>


int sound_handle;		//sound handler
int elapsed_seconds;

char outport[8];

pid_t pid_sop;
pid_t pid_player;
pid_t pid_channel;

GtkWidget *window1;
GtkWidget *entry_player;
GtkWidget *entry_status;
GtkWidget *entry_url;
GtkWidget *entry_url_header;
GtkWidget *entry_record_dir;
char channels_url[64];
char channels_url_header[64];
char record_dir[64];
GtkWidget *clist_channel;
GtkWidget *button_channel;
GtkWidget *button_record;

char *title;
int title_len;


int kill_player;

int flag_buf_rec;
