
#include "header.h"

int
main (int argc, char *argv[])
{
//  GtkWidget *window1;
  GtkWidget *notebook1;
  GtkWidget *vbox;
  GtkWidget *scrolledwindow1;
//  GtkWidget *clist_channel;
  GtkWidget *label;
  GtkWidget *hbox;
  GtkWidget *button_sopcast;
  GtkWidget *button_player;
//  GtkWidget *button_channel;
  GtkWidget *button_stop;
  GtkWidget *button_exit;
//  GtkWidget *button_record;
  GtkWidget *hscale_sound;
//  GtkWidget *entry_status;
//  GtkWidget *entry_player;
//  GtkWidget *entry_url_header;
  GtkWidget *button_save;
  GtkObject *adj_sound;


  g_thread_init (NULL);
  gdk_threads_init ();
  gtk_init (&argc, &argv);

  window1 = gtk_window_new (GTK_WINDOW_TOPLEVEL);
//  gtk_widget_set_usize (GTK_WIDGET (window1), 450, 350);
  gtk_window_set_title (GTK_WINDOW (window1), "gtk-sopcast");

  notebook1 = gtk_notebook_new ();
  gtk_widget_show (notebook1);
  gtk_container_add (GTK_CONTAINER (window1), notebook1);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox), scrolledwindow1, TRUE, TRUE, 0);
//  gtk_scrolled_window_set_shadow_type (GTK_SCROLLED_WINDOW (scrolledwindow1),
//                                     GTK_SHADOW_IN);

  clist_channel = gtk_clist_new (9);
  gtk_widget_show (clist_channel);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), clist_channel);
  gtk_clist_set_column_width (GTK_CLIST (clist_channel), 0, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist_channel), 1, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist_channel), 2, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist_channel), 3, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist_channel), 4, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist_channel), 5, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist_channel), 6, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist_channel), 7, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist_channel), 8, 80);
//  gtk_clist_set_selection_mode (GTK_CLIST (clist_channel), GTK_SELECTION_BROWSE);
  gtk_clist_column_titles_show (GTK_CLIST (clist_channel));

  label = gtk_label_new ("Num");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (clist_channel), 0, label);

  label = gtk_label_new ("Channel");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (clist_channel), 1, label);

  label = gtk_label_new ("Type");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (clist_channel), 2, label);

  label = gtk_label_new ("Kbps");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (clist_channel), 3, label);

  label = gtk_label_new ("Users");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (clist_channel), 4, label);

  label = gtk_label_new ("NetQua");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (clist_channel), 5, label);

  label = gtk_label_new ("SerQua");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (clist_channel), 6, label);

  label = gtk_label_new ("StartTime");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (clist_channel), 7, label);

  label = gtk_label_new ("URL");
  gtk_widget_show (label);
  gtk_clist_set_column_widget (GTK_CLIST (clist_channel), 8, label);

  hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);

  button_sopcast = gtk_button_new_with_label ("Sopcast");
  gtk_widget_show (button_sopcast);
  gtk_box_pack_start (GTK_BOX (hbox), button_sopcast, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (button_sopcast), GTK_RELIEF_NONE);
  gtk_button_set_focus_on_click (GTK_BUTTON (button_sopcast), FALSE);

  button_player = gtk_button_new_with_label ("Player");
  gtk_widget_show (button_player);
  gtk_box_pack_start (GTK_BOX (hbox), button_player, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (button_player), GTK_RELIEF_NONE);
  gtk_button_set_focus_on_click (GTK_BUTTON (button_player), FALSE);

  button_channel = gtk_toggle_button_new_with_label ("Channel");
  gtk_widget_show (button_channel);
  gtk_box_pack_start (GTK_BOX (hbox), button_channel, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (button_channel), GTK_RELIEF_NONE);
  gtk_button_set_focus_on_click (GTK_BUTTON (button_channel), FALSE);


  button_stop = gtk_button_new_with_label ("Stop");
  gtk_widget_show (button_stop);
  gtk_box_pack_start (GTK_BOX (hbox), button_stop, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (button_stop), GTK_RELIEF_NONE);
  gtk_button_set_focus_on_click (GTK_BUTTON (button_stop), FALSE);

  button_exit = gtk_button_new_with_label ("Exit");
  gtk_widget_show (button_exit);
  gtk_box_pack_start (GTK_BOX (hbox), button_exit, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (button_exit), GTK_RELIEF_NONE);
  gtk_button_set_focus_on_click (GTK_BUTTON (button_exit), FALSE);


///////////open mixer

  if ((sound_handle = open ("/dev/mixer", O_RDWR, 0)) == -1)
    {
      perror ("/dev/mixer");
      return;
    }

  void on_adj_sound_change_value ();

  adj_sound = gtk_adjustment_new (sound_read (), 0, 100, 1, 0, 0);
  gtk_signal_connect (GTK_OBJECT (adj_sound), "value_changed",
		      GTK_SIGNAL_FUNC (on_adj_sound_change_value), NULL);


  hscale_sound = gtk_hscale_new (GTK_ADJUSTMENT (adj_sound));
  gtk_widget_show (hscale_sound);
  gtk_box_pack_start (GTK_BOX (hbox), hscale_sound, TRUE, TRUE, 0);
  gtk_scale_set_digits (GTK_SCALE (hscale_sound), 0);

  button_record = gtk_button_new_with_label ("Record");
  gtk_widget_show (button_record);
  gtk_box_pack_start (GTK_BOX (hbox), button_record, FALSE, FALSE, 0);
  gtk_button_set_relief (GTK_BUTTON (button_record), GTK_RELIEF_NONE);
  gtk_button_set_focus_on_click (GTK_BUTTON (button_record), FALSE);


  entry_status = gtk_entry_new ();
  gtk_widget_show (entry_status);
  gtk_box_pack_start (GTK_BOX (vbox), entry_status, FALSE, FALSE, 0);

  label = gtk_label_new ("sopcast");
  gtk_widget_show (label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1),
			      gtk_notebook_get_nth_page (GTK_NOTEBOOK
							 (notebook1), 0),
			      label);

  vbox = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox);
  gtk_container_add (GTK_CONTAINER (notebook1), vbox);
////
  label = gtk_label_new ("Configuration");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (vbox), label, TRUE, FALSE, 0);
////
  hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);

  label = gtk_label_new (" Player: ");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);

  entry_player = gtk_entry_new ();
  gtk_widget_show (entry_player);
  gtk_box_pack_start (GTK_BOX (hbox), entry_player, TRUE, TRUE, 0);
  ////
  hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);

  label = gtk_label_new (" Channels url: ");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);

  entry_url = gtk_entry_new ();
  gtk_widget_show (entry_url);
  gtk_box_pack_start (GTK_BOX (hbox), entry_url, TRUE, TRUE, 0);

////
  hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);

  label = gtk_label_new (" Channels url header: ");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);

  entry_url_header = gtk_entry_new ();
  gtk_widget_show (entry_url_header);
  gtk_box_pack_start (GTK_BOX (hbox), entry_url_header, TRUE, TRUE, 0);
////
  hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);

  label = gtk_label_new (" Record directory: ");
  gtk_widget_show (label);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, FALSE, 0);

  entry_record_dir = gtk_entry_new ();
  gtk_widget_show (entry_record_dir);
  gtk_box_pack_start (GTK_BOX (hbox), entry_record_dir, TRUE, TRUE, 0);
  ///
  hbox = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox);
  gtk_box_pack_start (GTK_BOX (vbox), hbox, TRUE, FALSE, 0);

  button_save = gtk_button_new_with_label (" Save ");
  gtk_widget_show (button_save);
  gtk_box_pack_start (GTK_BOX (hbox), button_save, TRUE, FALSE, 0);
///
  label = gtk_label_new ("config");
  gtk_widget_show (label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1),
			      gtk_notebook_get_nth_page (GTK_NOTEBOOK
							 (notebook1), 1),
			      label);

  label =
    gtk_label_new
    ("gtk-sopcast is a gtk front-end to sopcast\n\nAuthor: Wei Lian\nhttp://lianwei3.googlepages.com/home2\n\nBuilt on the work of pinkme005 and zlbruce");
  gtk_widget_show (label);
  gtk_container_add (GTK_CONTAINER (notebook1), label);

  label = gtk_label_new ("about");
  gtk_widget_show (label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook1),
			      gtk_notebook_get_nth_page (GTK_NOTEBOOK
							 (notebook1), 2),
			      label);


  void on_button_save_clicked ();
  void on_window1_destroy ();
  void on_button_sopcast_clicked ();
  void on_button_player_clicked ();
  void on_button_channel_toggled ();
  void on_button_stop_clicked ();
  void on_button_exit_clicked ();
  void on_button_record_clicked ();

  void on_clist_channel_select_row ();

  gtk_signal_connect (GTK_OBJECT (button_save), "clicked",
		      GTK_SIGNAL_FUNC (on_button_save_clicked), NULL);
  gtk_signal_connect (GTK_OBJECT (window1), "destroy",
		      GTK_SIGNAL_FUNC (on_window1_destroy), NULL);
  gtk_signal_connect (GTK_OBJECT (button_sopcast), "clicked",
		      GTK_SIGNAL_FUNC (on_button_sopcast_clicked), NULL);
  gtk_signal_connect (GTK_OBJECT (button_player), "clicked",
		      GTK_SIGNAL_FUNC (on_button_player_clicked), NULL);
  gtk_signal_connect (GTK_OBJECT (button_channel), "toggled",
		      GTK_SIGNAL_FUNC (on_button_channel_toggled), NULL);
  gtk_signal_connect (GTK_OBJECT (button_stop), "clicked",
		      GTK_SIGNAL_FUNC (on_button_stop_clicked), NULL);
  gtk_signal_connect (GTK_OBJECT (button_exit), "clicked",
		      GTK_SIGNAL_FUNC (on_button_exit_clicked), NULL);
  gtk_signal_connect (GTK_OBJECT (button_record), "clicked",
		      GTK_SIGNAL_FUNC (on_button_record_clicked), NULL);

  gtk_signal_connect (GTK_OBJECT (clist_channel), "select_row",
		      GTK_SIGNAL_FUNC (on_clist_channel_select_row), NULL);

///////////////////////////////////////////////////
///////////setup signal
  signal (SIGPIPE, SIG_IGN);

  struct sigaction act, old_chld_act, old_alrm_act;
/////setup child signal 

  void sig_child_callback (int);
  act.sa_handler = sig_child_callback;
//  act.sa_handler = SIG_IGN;
  sigfillset (&act.sa_mask);
//  sigaddset (&act.sa_mask, SIGALRM);  //necessary to avoid data corruption
  act.sa_flags = SA_NOCLDSTOP;	//SA_NOCLDWAIT|SA_NOCLDSTOP;

  sigaction (SIGCHLD, &act, &old_chld_act);
/////setup alarm signal

  void sig_alarm_callback ();
  act.sa_handler = sig_alarm_callback;
  sigemptyset (&act.sa_mask);
  sigaddset (&act.sa_mask, SIGCHLD);	//necessary for normal function
  act.sa_flags = 0;

  sigaction (SIGALRM, &act, &old_alrm_act);
///////////initialize value
  pid_channel = -2;

  title = NULL;
  title_len = 0;

  pid_player = -2;
  pid_sop = -2;
///////////initialize player infor
  char *line = NULL;
  size_t len = 0;
  ssize_t read;
  char *strtok_buffer = NULL;
  char *data_path;
  data_path =
    malloc (strlen (getenv ("HOME")) + strlen ("/.gtk-sopcast/config") + 1);
  strcpy (data_path, getenv ("HOME"));
  strcat (data_path, "/.gtk-sopcast/config");

  FILE *fp = fopen (data_path, "r");
  free (data_path);
  //assigning default value
#define DEFAULT_UPDATE_URL	"http://202.101.35.149/gchlxml"
#define DEFAULT_UPDATE_URL2	"http://www.sopcast.com/gchlxml"
  strcpy (channels_url,DEFAULT_UPDATE_URL2);
  strcpy (channels_url_header, "sop://broker.sopcast.org");
  strcpy (record_dir, getenv ("HOME"));
  strcat (record_dir, "/SOPCAST/");
  int width = 450, height = 350;
  if (fp == NULL)
    {
      gtk_entry_set_text (GTK_ENTRY (entry_player),
			  "mplayer -ontop -geometry 100%:100%");
      gtk_entry_set_text (GTK_ENTRY (entry_url), channels_url);
      gtk_entry_set_text (GTK_ENTRY (entry_url_header), channels_url_header);
      gtk_entry_set_text (GTK_ENTRY (entry_record_dir), record_dir);
      gtk_widget_set_usize (GTK_WIDGET (window1), width, height);
      gtk_window_set_policy (GTK_WINDOW (window1), TRUE, TRUE, FALSE);

    }
  else
    {
      ///player
      if ((read = getline (&line, &len, fp)) == -1)
	gtk_entry_set_text (GTK_ENTRY (entry_player),
			    "aoss mplayer -ontop -geometry 100%:100%");
      else
	{
	  strtok_r (line, "\n", &strtok_buffer);
	  gtk_entry_set_text (GTK_ENTRY (entry_player), line);
	}
      ///channels_url_header
      if ((read = getline (&line, &len, fp)) == -1)
	gtk_entry_set_text (GTK_ENTRY (entry_url_header),
			    channels_url_header);
      else
	{
	  strtok_r (line, "\n", &strtok_buffer);
	  gtk_entry_set_text (GTK_ENTRY (entry_url_header), line);
	  strcpy (channels_url_header, line);
	}

      ///channels_url
      if ((read = getline (&line, &len, fp)) == -1)
	gtk_entry_set_text (GTK_ENTRY (entry_url), channels_url);
      else
	{
	  strtok_r (line, "\n", &strtok_buffer);
	  gtk_entry_set_text (GTK_ENTRY (entry_url), line);
	  strcpy (channels_url, line);
	}
      ///record_dir
      if ((read = getline (&line, &len, fp)) == -1)
	gtk_entry_set_text (GTK_ENTRY (entry_record_dir), record_dir);
      else
	{
	  strtok_r (line, "\n", &strtok_buffer);
	  gtk_entry_set_text (GTK_ENTRY (entry_record_dir), line);
	  strcpy (record_dir, line);
	}
      ///load win size
      if ((read = getline (&line, &len, fp)) != -1)
	{
	  strtok_r (line, "\n", &strtok_buffer);
	  width = atoi (line);
	  width = width >= 342 ? width : 342;
	  width = width <= 800 ? width : 800;
	}
      if ((read = getline (&line, &len, fp)) != -1)
	{
	  strtok_r (line, "\n", &strtok_buffer);
	  height = atoi (line);
	  height = height >= 161 ? height : 161;
	  height = height <= 600 ? height : 600;
	}
      gtk_widget_set_usize (GTK_WIDGET (window1), width, height);
      gtk_window_set_policy (GTK_WINDOW (window1), TRUE, TRUE, FALSE);

      fclose (fp);
      if (line)
	free (line);
    }
///////////////////dup stdout  
  int fd = open ("/dev/zero", O_WRONLY);
  dup2 (fd, 1);
///////////////////main loop
  get_channel_list (0);		//load channel list
  gtk_widget_show (window1);
  gtk_clist_columns_autosize (GTK_CLIST (clist_channel));
  gtk_main ();
/////////////restore signal
  sigaction (SIGCHLD, &old_chld_act, NULL);
  sigaction (SIGALRM, &old_alrm_act, NULL);
////////////close aumix
  close (sound_handle);
  if (title)
    {
      free (title);
    }
  fprintf (stderr, "gtk-sopcast exit\n");
  return 0;
}
